// Obtain GSM Location from a SIM800L Module
//
// Use AT+CNETSCAN to scan cellular network info including tower location
// The oputput data should look like this:
// “T-Mobile”,MCC:234,MNC:30,Rxlev:53,Cellid:74E2,Arfcn:649,Lac:09E1,Bsic:11
// Plug that into CellTower Locator at www.cell2gps.com
// (NOTE: Cell ID and LAC must first be converted from HEX to Decimal)

#include <SoftwareSerial.h>
SoftwareSerial SerialGSM(16, 17);  // RX, TX

#define TINY_GSM_DEBUG Serial
#define TINY_GSM_MODEM_SIM800
#include <TinyGsmClient.h>
TinyGsm        modem(SerialGSM);

void setup() {
  // Set Baud Rate for Serial Monitor Output
  Serial.begin(115200);
  delay(5000);
  // Set GSM Modem Baud Rate
  SerialGSM.begin(9600);

  String name = modem.getModemName();
  DBG("Modem Name:", name);

  String modemInfo = modem.getModemInfo();
  DBG("Modem Info:", modemInfo);
}

void loop() {
  modem.sendAT(GF("+CNETSCAN"));
  if (modem.waitResponse(10000L, GF("Operator:")) == 1)
  {
    String res1 = SerialGSM.readStringUntil('\n');
    modem.waitResponse();
    Serial.print("Data:");
    Serial.println(res1);
  }
}
